GetPrivateProfileStringML   proc uses edi esi lpSection:DWORD,lpKey:DWORD,lpDefault:DWORD,lpBuffer:DWORD,nSize:DWORD,lpFile:DWORD
    invoke CreateFile,lpFile,GENERIC_READ,FILE_SHARE_READ,\
                        0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, 0						; handle in eax
    mov hOpenFile,eax
    .if eax!=INVALID_HANDLE_VALUE               ; if file is valid
        invoke GetFileSize,hOpenFile,0          ; get lpFile size
        inc eax                                 ; add one (null)
        mov nFileSize,eax                       ; save value
        invoke LocalAlloc,GPTR,eax              ; allocate that much ram
        mov hMem,eax                            ; save memory offset
        invoke ReadFile,hOpenFile,hMem,nFileSize,addr hOpenFileSize,0

        mov edi,hMem                            ; source pointer
        mov esi,lpSection                       ; search pointer
begin:                                          ; loop until "[" found
        mov al,byte ptr [edi]                   ; fetch source byte
        inc edi                                 ; increment source pointer
        cmp al,"["                              ; is it a "["
        jz @F                                   ; if found, break
        cmp al,00                               ; else is it a null?
        jz copydef                              ; if so, section not found!
        jmp begin                               ; else loop
@@:                                             ; "[" found
        mov al,byte ptr [edi]                   ; fetch source byte
        mov ah,byte ptr [esi]                   ; fetch section byte
        cmp al,"]"                              ; if we've reached "]" w/o err
        jz @F                                   ; sections match!
        inc esi                                 ; increment pointers
        inc edi                                 ;
        cmp al,ah                               ; compare bytes
        jz  @B                                  ; loop until a difference found
        jmp begin                               ; if none match, search again
@@:                                             ; sections match!
        add edi,3                               ; skip over "]" and CR+LF
        mov esi,lpKey                           ; get pointer of key to find
findit:                                         ; find lpKey within lpSection
        mov al,byte ptr [edi]                   ; fetch source byte
        mov ah,byte ptr [esi]                   ; fetch key byte
        cmp al,"="                              ; if we've reached "=" w/o err
        jz found                                ; keys match
        cmp al,"["                              ; if we found another section,
        jz copydef                              ; key not found
        cmp al,00                               ; if we read a null,
        jz copydef                              ; something terribly wrong
        inc esi                                 ; increment pointers
        inc edi                                 ;
        cmp al,ah                               ; compare bytes
        jz  findit                              ; loop until a difference found
@@:                                             ; no match, goto next line
        mov al,byte ptr [edi]                   ; fetch source byte
        inc edi                                 ; increment pointer
        cmp al,10                               ; LF char?
        jnz @B                                  ; loop while not LF
        mov esi,lpKey                           ; reset key pointer
        jmp findit                              ; try key search again
found:                                          ; key matched!
        inc edi                                 ; skip over "="
        mov esi,lpBuffer                        ; esi as output ptr
@@:                                             ; copy data src to dest
        mov al,byte ptr [edi]                   ; fetch source byte
        cmp al,"="                              ; if we've found another key,
        jz @F                                   ; erase its name from output
        cmp al,"["                              ; if we've found another section,
        jz nullify                              ; just terminate output string
        mov byte ptr [esi],al                   ; put byte in dest buffer
        inc edi                                 ; increment pointers
        inc esi                                 ; 
        test al,al                              ; if it was a null,
        jz done                                 ; we're done
        jmp @B                                  ; else keep copying
@@:                                             ; erase last xxxx= from buffer
        mov al,byte ptr [esi]                   ; fetch destination byte
        mov byte ptr [esi],00                   ; overwrite with a null
        dec esi                                 ; decrement dest pointer
        cmp al,13                               ; was last byte a CR?
        jnz @B                                  ; loop until last line is deleted
        jmp done                                ; we're done. :)
nullify:                                        ; if a last null is needed
        mov byte ptr [esi],00                   ; output a null
        jmp done                                ;
copydef:                                        ; else copy lpDefault
        mov edi,lpDefault                       ; default as source ptr
@@:                                             ; loop until string copied
        mov al,byte ptr [edi]                   ; fetch source byte
        mov byte ptr [esi],al                   ; output
        test al,al                              ; was byte a null?
        jnz @B                                  ; loop intil null copied
done:                                           ; we're done!
        mov eax,1                               ; return "good" value
        invoke LocalFree,hMem                   ; free memory
    .else                                       ; or if error opening file
        mov eax,0                               ; return "error" value
    .endif

    .if hOpenFile!=0                            ; if we have a file handle open,
        invoke CloseHandle,hOpenFile            ; free it
    .endif
    ret
GetPrivateProfileStringML   endp